org.apache.activemq.artemis.jms.server

## Interface JMSServerManager

- All Superinterfaces:
    org.apache.activemq.artemis.core.server.ActiveMQComponent
  All Known Implementing Classes:
    JMSServerManagerImpl

      public interface JMSServerManager
      extends org.apache.activemq.artemis.core.server.ActiveMQComponent

  The JMS Management interface.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addAddressSettings(String address, org.apache.activemq.artemis.core.settings.impl.AddressSettings addressSettings)`
    `boolean` | `addConnectionFactoryToBindingRegistry(String name, String binding)`
    `boolean` | `addQueueToBindingRegistry(String queueName, String binding)`
    `void` | `addSecurity(String addressMatch, Set<org.apache.activemq.artemis.core.security.Role> roles)`
    `boolean` | `addTopicToBindingRegistry(String topicName, String binding)`
    `boolean` | `closeConnectionsForAddress(String ipAddress)`
    `boolean` | `closeConnectionsForUser(String address)`
    `boolean` | `closeConsumerConnectionsForAddress(String address)`
    `void` | `createConnectionFactory(boolean storeConfig, ConnectionFactoryConfiguration cfConfig, String... bindings)`
    `void` | `createConnectionFactory(String name, boolean ha, JMSFactoryType cfType, List<String> connectorNames, String... bindings)`
    `void` | `createConnectionFactory(String name, boolean ha, JMSFactoryType cfType, List<String> connectorNames, String clientID, long clientFailureCheckPeriod, long connectionTTL, long callTimeout, long callFailoverTimeout, boolean cacheLargeMessagesClient, int minLargeMessageSize, boolean compressLargeMessage, int consumerWindowSize, int consumerMaxRate, int confirmationWindowSize, int producerWindowSize, int producerMaxRate, boolean blockOnAcknowledge, boolean blockOnDurableSend, boolean blockOnNonDurableSend, boolean autoGroup, boolean preAcknowledge, String loadBalancingPolicyClassName, int transactionBatchSize, int dupsOKBatchSize, boolean useGlobalPools, int scheduledThreadPoolMaxSize, int threadPoolMaxSize, long retryInterval, double retryIntervalMultiplier, long maxRetryInterval, int reconnectAttempts, boolean failoverOnInitialConnection, String groupId, String... bindings)`
    `void` | `createConnectionFactory(String name, boolean ha, JMSFactoryType cfType, String discoveryGroupName, String... bindings)`
    `void` | `createConnectionFactory(String name, boolean ha, JMSFactoryType cfType, String discoveryGroupName, String clientID, long clientFailureCheckPeriod, long connectionTTL, long callTimeout, long callFailoverTimeout, boolean cacheLargeMessagesClient, int minLargeMessageSize, boolean compressLargeMessages, int consumerWindowSize, int consumerMaxRate, int confirmationWindowSize, int producerWindowSize, int producerMaxRate, boolean blockOnAcknowledge, boolean blockOnDurableSend, boolean blockOnNonDurableSend, boolean autoGroup, boolean preAcknowledge, String loadBalancingPolicyClassName, int transactionBatchSize, int dupsOKBatchSize, boolean useGlobalPools, int scheduledThreadPoolMaxSize, int threadPoolMaxSize, long retryInterval, double retryIntervalMultiplier, long maxRetryInterval, int reconnectAttempts, boolean failoverOnInitialConnection, String groupId, String... bindings)`
    `boolean` | `createQueue(boolean storeConfig, String queueName, String selectorString, boolean durable, String... bindings)` Creates a JMS Queue.
    `boolean` | `createTopic(boolean storeConfig, String topicName, boolean autoCreated, String... bindings)`
    `boolean` | `createTopic(boolean storeConfig, String topicName, String... bindings)` Creates a JMS Topic
    `boolean` | `destroyConnectionFactory(String name)` destroys a connection factory.
    `boolean` | `destroyQueue(String name)` destroys a queue and removes it from the BindingRegistry
    `boolean` | `destroyQueue(String name, boolean removeConsumers)` destroys a queue and removes it from the BindingRegistry.
    `boolean` | `destroyTopic(String name)` destroys a topic and removes it from theBindingRegistry
    `boolean` | `destroyTopic(String name, boolean removeConsumers)` destroys a topic and removes it from the BindingRegistry
    `org.apache.activemq.artemis.core.server.ActiveMQServer` | `getActiveMQServer()`
    `org.apache.activemq.artemis.core.settings.impl.AddressSettings` | `getAddressSettings(String address)`
    `String[]` | `getBindingsOnConnectionFactory(String factoryName)`
    `String[]` | `getBindingsOnQueue(String queue)`
    `String[]` | `getBindingsOnTopic(String topic)`
    `BindingRegistry` | `getRegistry()`
    `Set<org.apache.activemq.artemis.core.security.Role>` | `getSecurity(String addressMatch)`
    `String` | `getVersion()`
    `boolean` | `isStarted()` Has the Server been started.
    `String[]` | `listConnectionIDs()`
    `String` | `listPreparedTransactionDetailsAsHTML()`
    `String` | `listPreparedTransactionDetailsAsJSON()`
    `String[]` | `listRemoteAddresses()`
    `String[]` | `listRemoteAddresses(String ipAddress)`
    `String[]` | `listSessions(String connectionID)`
    `String` | `listSessionsAsJSON(String connectionID)`
    `ActiveMQConnectionFactory` | `recreateCF(String name, ConnectionFactoryConfiguration cf)` Call this method to have a CF rebound to the Binding Registry and stored on the Journal
    `boolean` | `removeConnectionFactoryFromBindingRegistry(String name)`
    `boolean` | `removeConnectionFactoryFromBindingRegistry(String name, String binding)`
    `boolean` | `removeQueueFromBindingRegistry(String name)` Remove the queue from the BindingRegistry.
    `boolean` | `removeQueueFromBindingRegistry(String name, String binding)` Remove the queue from the BindingRegistry.
    `boolean` | `removeTopicFromBindingRegistry(String name)` Remove the topic from the BindingRegistry.
    `boolean` | `removeTopicFromBindingRegistry(String name, String binding)` Remove the topic from the Binding Registry or BindingRegistry.
    `void` | `setRegistry(BindingRegistry registry)` Set this property if you want JMS resources bound to a registry

    - ### Methods inherited from interface org.apache.activemq.artemis.core.server.ActiveMQComponent

      `start, stop`

- - ### Method Detail

    - #### getVersion

          String getVersion()

    - #### isStarted

          boolean isStarted()

      Has the Server been started.
      Specified by:
        `isStarted` in interface `org.apache.activemq.artemis.core.server.ActiveMQComponent`
      Returns:
        true if the server us running

    - #### createQueue

          boolean createQueue(boolean storeConfig,
                              String queueName,
                              String selectorString,
                              boolean durable,
                              String... bindings)
                       throws Exception

      Creates a JMS Queue.
      Parameters:
        `queueName` - The name of the queue to create
        `selectorString` -
        `durable` -
      Returns:
        true if the queue is created or if it existed and was added to the Binding Registry
      Throws:
        `Exception` - if problems were encountered creating the queue.

    - #### addTopicToBindingRegistry

          boolean addTopicToBindingRegistry(String topicName,
                                            String binding)
                                     throws Exception

      Throws:
        `Exception`

    - #### addQueueToBindingRegistry

          boolean addQueueToBindingRegistry(String queueName,
                                            String binding)
                                     throws Exception

      Throws:
        `Exception`

    - #### addConnectionFactoryToBindingRegistry

          boolean addConnectionFactoryToBindingRegistry(String name,
                                                        String binding)
                                                 throws Exception

      Throws:
        `Exception`

    - #### createTopic

          boolean createTopic(boolean storeConfig,
                              String topicName,
                              String... bindings)
                       throws Exception

      Creates a JMS Topic
      Parameters:
        `topicName` - the name of the topic
        `bindings` - the names of the binding for the Binding Registry or BindingRegistry
      Returns:
        true if the topic was created or if it existed and was added to the Binding Registry
      Throws:
        `Exception` - if a problem occurred creating the topic

    - #### createTopic

          boolean createTopic(boolean storeConfig,
                              String topicName,
                              boolean autoCreated,
                              String... bindings)
                       throws Exception

      Parameters:
        `storeConfig` -
        `topicName` -
        `autoCreated` -
        `bindings` -
      Returns:
      Throws:
        `Exception`

    - #### removeTopicFromBindingRegistry

          boolean removeTopicFromBindingRegistry(String name,
                                                 String binding)
                                          throws Exception

      Remove the topic from the Binding Registry or BindingRegistry. Calling this method does not destroy the destination.
      Parameters:
        `name` - the name of the destination to remove from the BindingRegistry
      Returns:
        true if removed
      Throws:
        `Exception` - if a problem occurred removing the destination

    - #### removeTopicFromBindingRegistry

          boolean removeTopicFromBindingRegistry(String name)
                                          throws Exception

      Remove the topic from the BindingRegistry. Calling this method does not destroy the destination.
      Parameters:
        `name` - the name of the destination to remove from the BindingRegistry
      Returns:
        true if removed
      Throws:
        `Exception` - if a problem occurred removing the destination

    - #### removeQueueFromBindingRegistry

          boolean removeQueueFromBindingRegistry(String name,
                                                 String binding)
                                          throws Exception

      Remove the queue from the BindingRegistry. Calling this method does not destroy the destination.
      Parameters:
        `name` - the name of the destination to remove from the BindingRegistry
      Returns:
        true if removed
      Throws:
        `Exception` - if a problem occurred removing the destination

    - #### removeQueueFromBindingRegistry

          boolean removeQueueFromBindingRegistry(String name)
                                          throws Exception

      Remove the queue from the BindingRegistry. Calling this method does not destroy the destination.
      Parameters:
        `name` - the name of the destination to remove from the BindingRegistry
      Returns:
        true if removed
      Throws:
        `Exception` - if a problem occurred removing the destination

    - #### removeConnectionFactoryFromBindingRegistry

          boolean removeConnectionFactoryFromBindingRegistry(String name,
                                                             String binding)
                                                      throws Exception

      Throws:
        `Exception`

    - #### removeConnectionFactoryFromBindingRegistry

          boolean removeConnectionFactoryFromBindingRegistry(String name)
                                                      throws Exception

      Throws:
        `Exception`

    - #### destroyQueue

          boolean destroyQueue(String name)
                        throws Exception

      destroys a queue and removes it from the BindingRegistry
      Parameters:
        `name` - the name of the queue to destroy
      Returns:
        true if destroyed
      Throws:
        `Exception` - if a problem occurred destroying the queue

    - #### destroyQueue

          boolean destroyQueue(String name,
                               boolean removeConsumers)
                        throws Exception

      destroys a queue and removes it from the BindingRegistry. disconnects any consumers connected to the queue.
      Parameters:
        `name` - the name of the queue to destroy
      Returns:
        true if destroyed
      Throws:
        `Exception` - if a problem occurred destroying the queue

    - #### getBindingsOnQueue

          String[] getBindingsOnQueue(String queue)

    - #### getBindingsOnTopic

          String[] getBindingsOnTopic(String topic)

    - #### getBindingsOnConnectionFactory

          String[] getBindingsOnConnectionFactory(String factoryName)

    - #### destroyTopic

          boolean destroyTopic(String name,
                               boolean removeConsumers)
                        throws Exception

      destroys a topic and removes it from the BindingRegistry
      Parameters:
        `name` - the name of the topic to destroy
      Returns:
        true if the topic was destroyed
      Throws:
        `Exception` - if a problem occurred destroying the topic

    - #### destroyTopic

          boolean destroyTopic(String name)
                        throws Exception

      destroys a topic and removes it from theBindingRegistry
      Parameters:
        `name` - the name of the topic to destroy
      Returns:
        true if the topic was destroyed
      Throws:
        `Exception` - if a problem occurred destroying the topic

    - #### recreateCF

          ActiveMQConnectionFactory recreateCF(String name,
                                               ConnectionFactoryConfiguration cf)
                                        throws Exception

      Call this method to have a CF rebound to the Binding Registry and stored on the Journal
      Throws:
        `Exception`

    - #### createConnectionFactory

          void createConnectionFactory(String name,
                                       boolean ha,
                                       JMSFactoryType cfType,
                                       String discoveryGroupName,
                                       String... bindings)
                                throws Exception

      Throws:
        `Exception`

    - #### createConnectionFactory

          void createConnectionFactory(String name,
                                       boolean ha,
                                       JMSFactoryType cfType,
                                       List<String> connectorNames,
                                       String... bindings)
                                throws Exception

      Throws:
        `Exception`

    - #### createConnectionFactory

          void createConnectionFactory(String name,
                                       boolean ha,
                                       JMSFactoryType cfType,
                                       List<String> connectorNames,
                                       String clientID,
                                       long clientFailureCheckPeriod,
                                       long connectionTTL,
                                       long callTimeout,
                                       long callFailoverTimeout,
                                       boolean cacheLargeMessagesClient,
                                       int minLargeMessageSize,
                                       boolean compressLargeMessage,
                                       int consumerWindowSize,
                                       int consumerMaxRate,
                                       int confirmationWindowSize,
                                       int producerWindowSize,
                                       int producerMaxRate,
                                       boolean blockOnAcknowledge,
                                       boolean blockOnDurableSend,
                                       boolean blockOnNonDurableSend,
                                       boolean autoGroup,
                                       boolean preAcknowledge,
                                       String loadBalancingPolicyClassName,
                                       int transactionBatchSize,
                                       int dupsOKBatchSize,
                                       boolean useGlobalPools,
                                       int scheduledThreadPoolMaxSize,
                                       int threadPoolMaxSize,
                                       long retryInterval,
                                       double retryIntervalMultiplier,
                                       long maxRetryInterval,
                                       int reconnectAttempts,
                                       boolean failoverOnInitialConnection,
                                       String groupId,
                                       String... bindings)
                                throws Exception

      Throws:
        `Exception`

    - #### createConnectionFactory

          void createConnectionFactory(String name,
                                       boolean ha,
                                       JMSFactoryType cfType,
                                       String discoveryGroupName,
                                       String clientID,
                                       long clientFailureCheckPeriod,
                                       long connectionTTL,
                                       long callTimeout,
                                       long callFailoverTimeout,
                                       boolean cacheLargeMessagesClient,
                                       int minLargeMessageSize,
                                       boolean compressLargeMessages,
                                       int consumerWindowSize,
                                       int consumerMaxRate,
                                       int confirmationWindowSize,
                                       int producerWindowSize,
                                       int producerMaxRate,
                                       boolean blockOnAcknowledge,
                                       boolean blockOnDurableSend,
                                       boolean blockOnNonDurableSend,
                                       boolean autoGroup,
                                       boolean preAcknowledge,
                                       String loadBalancingPolicyClassName,
                                       int transactionBatchSize,
                                       int dupsOKBatchSize,
                                       boolean useGlobalPools,
                                       int scheduledThreadPoolMaxSize,
                                       int threadPoolMaxSize,
                                       long retryInterval,
                                       double retryIntervalMultiplier,
                                       long maxRetryInterval,
                                       int reconnectAttempts,
                                       boolean failoverOnInitialConnection,
                                       String groupId,
                                       String... bindings)
                                throws Exception

      Throws:
        `Exception`

    - #### createConnectionFactory

          void createConnectionFactory(boolean storeConfig,
                                       ConnectionFactoryConfiguration cfConfig,
                                       String... bindings)
                                throws Exception

      Throws:
        `Exception`

    - #### destroyConnectionFactory

          boolean destroyConnectionFactory(String name)
                                    throws Exception

      destroys a connection factory.
      Parameters:
        `name` - the name of the connection factory to destroy
      Returns:
        true if the connection factory was destroyed
      Throws:
        `Exception` - if a problem occurred destroying the connection factory

    - #### listRemoteAddresses

          String[] listRemoteAddresses()
                                throws Exception

      Throws:
        `Exception`

    - #### listRemoteAddresses

          String[] listRemoteAddresses(String ipAddress)
                                throws Exception

      Throws:
        `Exception`

    - #### closeConnectionsForAddress

          boolean closeConnectionsForAddress(String ipAddress)
                                      throws Exception

      Throws:
        `Exception`

    - #### closeConsumerConnectionsForAddress

          boolean closeConsumerConnectionsForAddress(String address)
                                              throws Exception

      Throws:
        `Exception`

    - #### closeConnectionsForUser

          boolean closeConnectionsForUser(String address)
                                   throws Exception

      Throws:
        `Exception`

    - #### listConnectionIDs

          String[] listConnectionIDs()
                              throws Exception

      Throws:
        `Exception`

    - #### listSessions

          String[] listSessions(String connectionID)
                         throws Exception

      Throws:
        `Exception`

    - #### listSessionsAsJSON

          String listSessionsAsJSON(String connectionID)
                             throws Exception

      Throws:
        `Exception`

    - #### listPreparedTransactionDetailsAsJSON

          String listPreparedTransactionDetailsAsJSON()
                                               throws Exception

      Throws:
        `Exception`

    - #### listPreparedTransactionDetailsAsHTML

          String listPreparedTransactionDetailsAsHTML()
                                               throws Exception

      Throws:
        `Exception`

    - #### getActiveMQServer

          org.apache.activemq.artemis.core.server.ActiveMQServer getActiveMQServer()

    - #### addAddressSettings

          void addAddressSettings(String address,
                                  org.apache.activemq.artemis.core.settings.impl.AddressSettings addressSettings)

    - #### getAddressSettings

          org.apache.activemq.artemis.core.settings.impl.AddressSettings getAddressSettings(String address)

    - #### addSecurity

          void addSecurity(String addressMatch,
                           Set<org.apache.activemq.artemis.core.security.Role> roles)

    - #### getSecurity

          Set<org.apache.activemq.artemis.core.security.Role> getSecurity(String addressMatch)

    - #### getRegistry

          BindingRegistry getRegistry()

    - #### setRegistry

          void setRegistry(BindingRegistry registry)

      Set this property if you want JMS resources bound to a registry
      Parameters:
        `registry` -

Copyright © 2018 The Apache Software Foundation. All rights reserved.